CREATE TABLE IF NOT EXISTS `comments` (
  `sid`          mediumint(8) unsigned NOT NULL DEFAULT '0',
  `cid`          int(10) unsigned      NOT NULL AUTO_INCREMENT,
  `pid`          int(10) unsigned      NOT NULL DEFAULT '0',
  `date`         datetime              NOT NULL DEFAULT '1970-01-01 00:00:00',
  `last_update`  timestamp             NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `ipid`         varchar(32)           NOT NULL DEFAULT '',
  `subnetid`     varchar(32)           NOT NULL DEFAULT '',
  `subject`      varchar(50)           NOT NULL DEFAULT '',
  `subject_orig` enum('no','yes')      NOT NULL DEFAULT 'yes',
  `uid`          mediumint(8) unsigned NOT NULL DEFAULT '0',
  `points`       tinyint(4)            NOT NULL DEFAULT '0',
  `pointsorig`   tinyint(4)            NOT NULL DEFAULT '0',
  `pointsmax`    tinyint(4)            NOT NULL DEFAULT '0',
  `lastmod`      mediumint(8) unsigned NOT NULL DEFAULT '0',
  `reason`       tinyint(3) unsigned   NOT NULL DEFAULT '0',
  `signature`    varchar(32)           NOT NULL DEFAULT '',
  `len`          smallint(5) unsigned  NOT NULL DEFAULT '0',
  `karma_bonus`  enum('yes','no')      NOT NULL DEFAULT 'no',
  `karma`        smallint(6)           NOT NULL DEFAULT '0',
  `karma_abs`    smallint(5) unsigned  NOT NULL DEFAULT '0',
  `tweak_orig`   tinyint(4)            NOT NULL DEFAULT '0',
  `tweak`        tinyint(4)            NOT NULL DEFAULT '0',
  `badge_id`     tinyint(3) unsigned   NOT NULL DEFAULT '0',
  PRIMARY KEY        (`cid`),
  KEY `display`      (`sid`,`points`,`uid`),
  KEY `byname`       (`uid`,`points`),
  KEY `ipid`         (`ipid`),
  KEY `subnetid`     (`subnetid`),
  KEY `theusual`     (`sid`,`uid`,`points`,`cid`),
  KEY `countreplies` (`pid`,`sid`),
  KEY `uid_date`     (`uid`,`date`),
  KEY `date_sid`     (`date`,`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
