CREATE TABLE IF NOT EXISTS `journals` (
  `id`          mediumint(8) unsigned              NOT NULL AUTO_INCREMENT,
  `uid`         mediumint(8) unsigned              NOT NULL DEFAULT '0',
  `date`        datetime                           NOT NULL DEFAULT '1970-01-01 00:00:00',
  `description` varchar(80)                        NOT NULL DEFAULT '',
  `posttype`    tinyint(4)                         NOT NULL DEFAULT '2',
  `discussion`  mediumint(8) unsigned              DEFAULT NULL,
  `tid`         smallint(5) unsigned               NOT NULL DEFAULT '0',
  `last_update` timestamp                          NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `promotetype` enum('publicize','publish','post') NOT NULL DEFAULT 'publish',
  `srcid_32`    bigint(20) unsigned                NOT NULL DEFAULT '0',
  `srcid_24`    bigint(20) unsigned                NOT NULL DEFAULT '0',
  PRIMARY KEY       (`id`),
  KEY `uidarticle`  (`uid`),
  KEY `IDandUID`    (`id`,`uid`),
  KEY `tid`         (`tid`),
  KEY `discussion`  (`discussion`),
  KEY `uid_date_id` (`uid`,`date`,`id`),
  KEY `srcid_32`    (`srcid_32`),
  KEY `srcid_24`    (`srcid_24`),
  KEY `id_date`     (`id`,`date`),
  KEY `date`        (`date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
