CREATE TABLE IF NOT EXISTS `stories` (
`stoid`               mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
`sid` 		      varchar(16)  	    NOT NULL DEFAULT '',
`uid` 		      mediumint(8) unsigned NOT NULL DEFAULT '0',
`dept` 		      varchar(100) 	    NOT NULL DEFAULT '',
`time` 		      datetime 		    NOT NULL DEFAULT '1900-01-01 00:00:00',
`hits` 		      mediumint(8) unsigned NOT NULL DEFAULT '0',
`discussion` 	      mediumint(8) unsigned DEFAULT NULL,
`primaryskid` 	      smallint(6)  	    NOT NULL DEFAULT '1',
`tid` 		      int(11) 		    NOT NULL DEFAULT '49',
`submitter` 	      mediumint(8) unsigned NOT NULL DEFAULT '0',
`commentcount` 	      smallint(5) unsigned  NOT NULL DEFAULT '0',
`hitparade` 	      varchar(64) 	    NOT NULL DEFAULT '0,0,0,0,0,0,0',
`is_archived` 	      enum('no','yes') 	    NOT NULL DEFAULT 'no',
`in_trash` 	      enum('no','yes') 	    NOT NULL DEFAULT 'no',
`day_published`       date 		    NOT NULL DEFAULT '1900-01-01',
`qid` 		      mediumint(8) unsigned DEFAULT NULL,
`last_update` 	      timestamp    	    NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
`body_length` 	      mediumint(8) unsigned NOT NULL DEFAULT '0',
`word_count` 	      mediumint(8) unsigned NOT NULL DEFAULT '0',
`archive_last_update` datetime 	   	    NOT NULL DEFAULT '1970-01-01 00:00:00',
`sponsor` 	      tinyint(3) unsigned   DEFAULT '0',
`stuck` 	      enum('no','yes') 	    DEFAULT 'no',
`stuckpos` 	      tinyint(3) unsigned   DEFAULT '0',
`stuckendtime` 	      datetime 	 	    NOT NULL DEFAULT '1900-01-01 00:00:00',
PRIMARY KEY             (`stoid`),
UNIQUE KEY `sid`        (`sid`),
KEY `uid`  	        (`uid`),
KEY `is_archived`       (`is_archived`),
KEY `time` 	        (`time`),
KEY `submitter`         (`submitter`),
KEY `day_published`     (`day_published`),
KEY `skidtid` 	        (`primaryskid`,`tid`),
KEY `discussion_stoid`  (`discussion`,`stoid`),
KEY `time_stoid`        (`time`,`stoid`),
KEY `trash_time`        (`in_trash`,`time`),
KEY `ibfk_converttid_4` (`tid`),
KEY `stuckendtime` 	(`stuckendtime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC
