package Newslash::Eventd::Handler::Journal;
use Mojo::Base 'Newslash::Eventd::Handler';
use Data::Dumper;

sub post {
    my ($self, $item) = @_;

    my $events = $self->app->model('events');
    my $journal_id = $item->{related_id};
    my $uid = $item->{source_user_id};
    my $messages = $self->app->model('messages');

    $self->app->log->debug("event journal posted processing... id: $journal_id, uid: $uid");

    my $targets = $self->app->model('relations')->fans($uid);
    if (!@$targets) {
        $self->inactivate_event($item->{event_id}, -1);
        return;
    }

    my $journal = $self->app->model('journals')->select(journal_id => $journal_id);
    if (!$journal) {
        $self->app->log->warn("invalid journal. id: $journal_id") if !$journal;
        $self->inactivate_event($item->{event_id}, -2);
        return;
    }

    my $vars = { journal => $journal, };

    for my $target_uid (@$targets) {
        my $rs = $self->create_message(to => $target_uid,
                                       from => $uid,
                                       template => "message/journal_post",
                                       vars => $vars,
                                       code => 5, # code 5 is "friend's new journal entry"
                                       type => "notify");
        if ($rs) {
            $self->app->log->debug("message created. id: $item->{event_id}, to: $target_uid");
        }
        else {
            $self->app->log->debug("message cannot create. id: $item->{event_id}, to: $target_uid");
        }
    }

    $self->inactivate_event($item->{event_id}, 0);
    return 1;
}

1;
