package Newslash::Eventd::Handler::Submission;
use Mojo::Base 'Newslash::Eventd::Handler';
use Data::Dumper;

sub post {
    my ($self, $item) = @_;

    my $events = $self->app->model('events');
    my $submission_id = $item->{related_id};
    my $uid = $item->{source_user_id};
    my $messages = $self->app->model('messages');

    $self->app->log->debug("event submission posted processing... id: $submission_id, uid: $uid");

    my $targets = $self->app->model('users')->select(seclev => { ge => 100 });
    if (!@$targets) {
        $self->inactivate_event($item->{event_id}, -1);
        return;
    }

    my $submission = $self->app->model('submissions')->select(submission_id => $submission_id);
    if (!$submission) {
        $self->app->log->warn("invalid submission. id: $submission_id") if !$submission;
        $self->inactivate_event($item->{event_id}, -2);
        return;
    }

    for my $target (@$targets) {
        my $vars = { submission => $submission, };
        my $rs = $self->create_message(to => $target->{uid},
                                       from => $uid,
                                       template => "message/submission_post",
                                       vars => $vars,
                                       code => 6, # code 6 is "new submission"
                                       type => "notify");
        if (defined $rs) {
            if ($rs) {
                $self->app->log->debug("message created. id: $item->{event_id}, to: $target->{uid}");
            }
            else {
                $self->app->log->debug("message not created because of user settings. id: $item->{event_id}, to: $target->{uid}");
            }
        }
        else {
            $self->app->log->debug("message cannot create. id: $item->{event_id}, to: $target->{uid}");
        }
    }
    $self->inactivate_event($item->{event_id}, 0);
    return 1;
}

1;
