package Newslash::Model::Polls::Voters;
use Newslash::Model::Base -base;

sub select {
    my $self = shift;
    my $params = {@_};
    my $qid = $params->{question_id} || $params->{qid} || 0;
    my $uid = $params->{user_id} || $params->{uid} || 0;
    my $ip_id = $params->{ip_id} || "";
    my $limit = $params->{limit};

    my $where_clause = "";
    #my $limit_clause = "";
    #my $order_by_clause = "";
    my @query_param;

    if ($qid && $uid) {
        $where_clause = "WHERE qid = ? AND uid = ?";
        push @query_param, $qid, $uid;
    }
    elsif ($qid && $ip_id) {
        $where_clause = "WHERE qid = ? AND id = ?";
        push @query_param, $qid, $ip_id;
    }

    return if !$where_clause;

    my $limit_clause = "";
    if (defined $limit) {
        $limit_clause = "LIMIT $limit";
    }

    my $sql = <<"EOSQL";
SELECT pollvoters.*
  FROM pollvoters
  $where_clause
  ORDER BY time DESC
  $limit_clause
EOSQL

    my $dbh = $self->connect_db;
    my $sth = $dbh->prepare($sql);
    $sth->execute(@query_param);
    my $voters = $sth->fetchall_arrayref({});
    if (!$voters) {
        $self->disconnect_db();
        return;
    }
    $self->disconnect_db();

    return $voters;
}


1;
