package Newslash::Model::Users::Achievements;
use Newslash::Model::Base -base;

sub select {
    my $self = shift;
    my $params = {@_};

    my $uid = $params->{id} || $params->{uid} || $params->{user_id};
    return if !$uid;

    my $keys = { uid => "user_achievements.uid",
                 aid => "user_achievements.aid",
                 exponent => "user_achievements.exponent",
                 id => "user_achievements.id",
               };
    my $datetime_keys = { create_time => "user_achievements.createtime" };

    my ($where_clause, $where_values, $unique) = $self->build_where_clause(keys => $keys,
                                                                           datetime_keys => $datetime_keys,
                                                                           params => $params);
    my ($limit_clause, $limit_values) = $self->build_limit_clause(params => $params);
    my ($orderby_clause, $orderby_values) = $self->build_order_by_clause(keys => $keys,
                                                                         datetime_keys => $datetime_keys,
                                                                         params => $params);

    my $sql = <<"EOSQL";
SELECT * FROM user_achievements
  LEFT JOIN achievements ON user_achievements.aid = achievements.aid
  $where_clause
  $orderby_clause
  $limit_clause
EOSQL

    my $dbh = $self->connect_db;
    my $sth = $dbh->prepare($sql);

    my @attrs;
    push @attrs, @$where_values, @$limit_values, @$orderby_values;

    $sth->execute(@attrs);
    my $rs = $sth->fetchall_arrayref({});
    if (!defined $rs) {
        $self->set_error($dbh->errstr, $dbh->err);
        $self->disconnect_db;
        return;
    }
    $self->disconnect_db;
    return $rs;
}


1;
