package Newslash::Model::Users::Info;
use Newslash::Model::Base -base;

sub key_definition {
    return {
            table => "users_info",
            primary => "uid",
            datetime => [qw(lastgranted lastm2 lastaccess)],
            timestamp => "created_at",
            addable => [qw(totalmods tokens karma maillist totalcomments
                           m2fair up_fair down_fair m2unfair up_unfair down_unfair
                           m2fairvotes m2voted_up_fair m2voted_down_fair
                           m2unfairvotes m2voted_up_unfair m2voted_down_unfair
                           m2voted_lonedissent m2voted_majority
                           upmods downmods stirred
                           session_login registered expiry_days expiry_comm
                           user_expiry_days user_expiry_comm tag_clout csq_bonuses)],
            other => [qw(realname bio m2info m2_mods_saved cookie_location
                         reg_id initdomain created_ipid people people_status)],
            aliases => { user_id => "uid",
                         id => "uid",
                         create_time => "created_at",
                       }
           };
}

sub select {
    my $self = shift;
    my $params = {@_};
    return $self->generic_select(params => $params);
}

sub update {
    my $self = shift;
    my $params = {@_};
    return $self->generic_update(params => $params);
}

1;
