package Newslash::Model::Users::Permissions;
use Newslash::Model::Base -base;

use constant {
    PERMIT_ACCESS => 'access',
      PERMIT_COMMENT => 'comment',
      PERMIT_SUBMISSION => 'submission',
      PERMIT_M1 => 'm1',
  };

sub get {
    my $self = shift;
    my $params = {@_};

    return if (!$params->{uid} && !$params->{user});

    my $user = $params->{user};
    my $users = $self->new_instance_of("Users");
    if (!$user) {
        $user = $users->selecr(uid => $params->{uid});
    }
    return if !$user;

    my $permissions = {
                       PERMIT_ACCESS() => 1,
                       PERMIT_COMMENT() => 1,
                       PERMIT_SUBMISSION() => 1,
                       PERMIT_M1() => 1,
                      };


    if ($user->{is_login}) {
        my $acl2 = $users->acl2->select(uid => $user->{uid});
        my $acl_of = {};
        if ($acl2 && $acl2->{values}) {
            for my $item (@{$acl2->{values}}) {
                $acl_of->{$item->{name}} = $item;
            }
        }

        $permissions->{access} = 0 if $acl_of->{ban};
        $permissions->{comment} = 0 if $acl_of->{nopost};
        $permissions->{submission} = 0 if $acl_of->{nosubmit};
        $permissions->{m1} = 0 if $acl_of->{nom1};
        if ($acl_of->{spammer}) {
            $permissions->{comment} = 0;
            $permissions->{submission} = 0;
            $permissions->{m1} = 0;
        }
    }
    else {
        # check by src_id
        for my $srcid (values %{$user->{srcid}->{24}}) {
            next if !$srcid;
            my $acl2 = $users->acl2->select(srcid => $srcid);
            my $acl_of = {};
            if ($acl2 && $acl2->{values}) {
                for my $item (@{$acl2->{values}}) {
                    $acl_of->{$item->{name}} = $item;
                }
            }
            $permissions->{access} = 0 if $acl_of->{ban};
            $permissions->{comment} = 0 if $acl_of->{nopost};
            $permissions->{submission} = 0 if $acl_of->{nosubmit};
            $permissions->{m1} = 0 if $acl_of->{nom1};
            if ($acl_of->{spammer}) {
                $permissions->{comment} = 0;
                $permissions->{submission} = 0;
                $permissions->{m1} = 0;
            }
        }
    }
    return $permissions;
}

1;
