package Newslash::Model::Users::User;
use strict;
use warnings;
use utf8;
use feature ':5.10';

sub new {
    my ($class, $users, $user_hash) = @_;
    $user_hash->{_model} = $users;
    bless $user_hash, $class;
}


sub friends {
    my $self = shift;
    return $self->{_model}->friends->friends(uid => $self->{uid});
}

sub foes {
    my $self = shift;
    return $self->{_model}->friends->foes(uid => $self->{uid});
}

sub fans {
    my $self = shift;
    return $self->{_model}->friends->fans(uid => $self->{uid});
}

sub freaks {
    my $self = shift;
    return $self->{_model}->friends->frieks(uid => $self->{uid});
}

sub sidebar_items {
    my $self = shift;

    my $boxes = $self->{_model}->new_instance_of("Newslash::Model::Boxes");
    my $user_sidebar = $self->{_model}->sidebar->select(uid => $self->{uid});

    if (!$user_sidebar) {
        $user_sidebar = $self->{_model}->sidebar->select(uid => $self->{_model}->anonymous_user->{uid});
    }

    # fallback
    my $items = $user_sidebar ? $user_sidebar->{items} : [1, 2];

    my $user_boxes = [];
    for my $box_id (@$items) {
        my $box = $boxes->select(id => $box_id);
        if (!$box) {
            $box = {template => "error: invalid sidebar item; ID is $box_id"};
        }
        push @$user_boxes, $box;
    }
    return $user_boxes;
}

sub prefs {
    my $self = shift;
    my $prefs = $self->{_model}->prefs->select(id => $self->{uid});
    return if !$prefs;

    if ($prefs->{tzcode}) {
        $prefs->{offset_sec} = Newslash::Util::Timezones::get_timezone_offset($prefs->{tzcode});
    }

    return $prefs;
}


1;
