package Newslash::Plugin::DiscussionHelper;
use Mojo::Base 'Mojolicious::Plugin';
use Data::Dumper;
sub register {
    my ($self, $app, $conf) = @_;

    $app->hook(before_render => sub {
                   my ($c, $args) = @_;
                   my $discus = $args->{discussion} || $c->stash('discussion');

                   my $page = $args->{page} || {};
                   if (!$discus) {
                       $page->{archived} = 0;
                       $page->{discussion_id} = 0;
                       return;
                   }

                   my $user = $c->stash('user');
                   my $discussions = $c->model('discussions');
                   my $comment_allowed = $discussions->is_comment_allowed(discussion => $discus,
                                                                          uid => $user->{uid});
                   $c->stash(comment_allowed => $comment_allowed);

                   $page->{archived} = ($discus->{type} && $discus->{type} eq 'archived') ? 1 : 0;
                   $page->{discussion_id} = $discus->{id} || 0;
                   $page->{comment_allowed} = $comment_allowed;

               });
}



1;
