package Newslash::Web::Controller::API::Relation;
use Mojo::Base 'Mojolicious::Controller';
use Mojo::Util qw(dumper);
use Mojo::JSON qw(decode_json encode_json to_json from_json);

sub post {
    my $c = shift;
    my $user = $c->stash('user');
    my $relations = $c->model('relations');

    my $data = $c->req->json;
    my $message = "invalid request";

    if (!$user->{is_login}) {
        $c->render(json => { error => 1, message => "you are not a valid user." });
        $c->rendered(400);
        return;
    }

    if ($data->{action} eq "update") {
        my $relation = $data->{relation};
        my $target_id = $data->{target_id};

        if ($target_id && defined $relation) {
            if ($relation eq "none") {
                my $rs = $relations->delete($user->{uid}, $target_id);
                if ($rs) {
                    $c->user_auth->update_user_cache($user);
                    $c->render(json => {message => "relation updated"});
                    $c->event_que->emit("relation", "delete", $user->{uid}, $target_id);
                    return;
                }
                $c->render(json => { error => 1, message => $relations->last_error });
                $c->rendered(400);
                return;
            } else {
                my $rs = $relations->create($user->{uid}, $target_id, $relation);
                if ($rs) {
                    $c->user_auth->update_user_cache($user);
                    $c->render(json => {message => "relation create/updated"});
                    $c->event_que->emit("relation", "update", $user->{uid}, $target_id);
                    return;
                }
                $c->render(json => { error => 1, message => $relations->last_error });
                $c->rendered(400);
                return;
            }
        }
    }

    $c->render(json => { error => 1, message => $message });
    $c->rendered(400);
    return;
}

1;
