package Newslash::Web::Controller::Comment;
use Mojo::Base 'Mojolicious::Controller';
use Mojo::Util qw(dumper);
use Data::Dumper;

sub single {
    my $c = shift;

    my $cid = $c->stash('cid');
    my $user = $c->stash('user');

    my $comments = $c->model('comments');
    my $comment = $comments->select(cid => $cid);

    if (!$comment) {
        $c->render('Not found', status => '404');
        return;
    }

    if ($comment->{public} && $comment->{public} eq 'no' && !$user->{is_admin}) {
        $c->render('Not found', status => '404');
        return;
    }

    my $discuss = $c->model('discussions')->select(id => $comment->{sid});
    my $parent;
    if ($comment->{pid}) {
        $parent = $comments->select(cid => $comment->{pid});
    }

    my $parent_item;
    if ($discuss) {
        my $d_id = $discuss->{discussion_id};
        if ($discuss->{kind} eq "poll") {
            $parent_item = $c->model('polls')->select(discussion_id => $d_id);
        }
        elsif ($discuss->{kind} eq "story"
            || $discuss->{kind} eq "journal-story") {
            $parent_item = $c->model('stories')->select(stoid => $discuss->{stoid});
        }
        elsif ($discuss->{kind} eq "journal") {
            $parent_item = $c->model('journals')->select(discussion_id => $d_id);
        }
        elsif ($discuss->{kind} eq "submission") {
            $parent_item = $c->model('submissions')->select(discussion_id => $d_id);
        }
    }

    my $page = { content_type => "comment",
                 type => "single",
                 comment_id => $comment->{cid},
                 cid => $comment->{cid},
                 parent_id => $comment->{pid},
                 pid => $comment->{pid},
                 stoid => $comment->{stoid},
                 story_id => $comment->{stoid},
                 sid => $comment->{sid},
               };

    $c->render(item => $comment,
               parent => $parent,
               discussion => $discuss,
               parent_item => $parent_item,
               page => $page,
              );
}


1;

