/* submissions-manager.js */
const submissionsManager = {};

submissionsManager.run = function run (params) {
  var vm;
  const data = {
    message: '',
    submissions: [],
    status: '',
    showDeletedSubjs: false,
    urls: {
      // update: '/admin/submissions/update',
      // get: '/admin/submissions/get',
      delete: '/admin/submissions/delete',
      list: '/api/v1/submissions',
    },
  };
  const computed = {};
  const methods = {
    updateItem: function updateItem(item) {
      var url = this.urls.list;
      if (this.showDeletedSubjs) {
        url = url + '?show_deleted=1'
      }
      this.$http.get(url).then(
        (resp) => { // success
          this.submissions = resp.body.items || [];
          this.message = resp.body.message || '';
          initItems(this.submissions);
          this.status = "";
        },
        (resp) => { // fail
          this.boxItems = [];
          this.message = resp.body.message || "failed to get items";
          this.status = "update_failed";
        }
      );
    },
    deleteItem: function deleteItem() {
      const target = [];
      for (var i = 0; i < this.boxItems.length; i++) {
        if (this.boxItems[i].selected) {
          target.push({id: this.boxItems[i].id, index: i});
        }
      }          
      if (target.length == 0) {
        return;
      }
      const msg = "delete " + target.length + " item(s)?";
      const result = window.confirm(msg);
      if (result) {
        // delete items
        target.reverse();
        target.forEach(item => {
          this.$http.post(vm.urls.delete, {id: item.id}).then(
            (response) => { // success
              if (response.body.error) {
                this.message = "error: " + response.body.message;
                return;
              }
              this.boxItems.splice(item.index, 1);
            },
            (response) => { // fail
            }
          );
        });
      }
    },
  };

  function initItems (items) {
    items.forEach(item => {
      Vue.set(item, 'choppedText', item.introtext.substr(0, 20) + '...');
      Vue.set(item, 'url', '/submission/' + item.subid);
      Vue.set(item, 'selected', false);
    });
  };

  vm = new Vue({el: params.el,
                data: data,
                computed: computed,
                methods: methods,
                created: function () {
                  this.$http.get(this.urls.list).then(
                    (resp) => { // success
                      this.submissions = resp.body.items || [];
                      this.message = resp.body.message || '';
                      initItems(this.submissions);
                    },
                    (resp) => { // fail
                      this.boxItems = [];
                      this.message = resp.body.message || "failed to get items";
                    }
                  );
                },
               });
};
