# -*-Perl-*-
# basic simple and non-destructive tests
use Mojo::Base -strict;
use Mojo::Date;
use Mojo::Util qw(dumper);

use Test::More;
use Test::Mojo;
use Newslash::Util::Test qw(create_admin_user create_user delete_user);

my $t = Test::Mojo->new('Newslash::Web');

if ($t->app->mode eq 'test') {
    my $user = create_admin_user($t->app, "test01", "foobar");
    ok($user, "create test user");
}

subtest 'login/logout test' => sub {
    $t->post_ok('/my/login' => {Accept => '*/*'} => form => {nickname => 'test01', passwd => 'foobar'})
      ->status_is(302);

    $t->get_ok('/admin/submissions')->status_is(200);
    $t->get_ok('/api/v1/submissions')->status_is(200);

    $t->get_ok('/my/logout')->status_is(302);
};

if ($t->app->mode eq 'test') {
    delete_user($t->app, "test01");
}


done_testing();
