# -*-Perl-*-
# destructive database-related  tests
use Mojo::Base -strict;
use Mojo::Date;

use Test::More;
use Test::Mojo;
use Mojo::Util qw(dumper);
use Newslash::Util::Test qw(create_user delete_user create_story delete_story);

my $t = Test::Mojo->new('Newslash::Web');

my $users = $t->app->model('users');


subtest 'update relation' => sub {
    plan skip_all => "mode is not 'test'" if ($t->app->mode ne 'test');

    # at first, create test users.
    my $user01 = create_user($t->app, "people1", "foobar");
    my $user02 = create_user($t->app, "people2", "foobar");
    ok($user01, "create test user 01");
    ok($user02, "create test user 02");

    # login
    $t->post_ok('/my/login' => {Accept => '*/*'} => form => {nickname => 'people1', passwd => "foobar"})
      ->status_is(302);

    # get csrf_token
    # $t->get_ok('/api/v1/token?rc=relation')->status_is(200);
    # my $token;
    # if ($t->tx->res->json) {
    #     if ($t->tx->res->json->{error}) {
    #         diag("message: " . $t->tx->res->json->{message});
    #     }
    #     $token = $t->tx->res->json->{token};
    #     ok($token, "retrive token 1");
    # }

    my $post_data = {
                     action => "update",
                     target_id => $user02->{uid},
                     relation => "friend",
                     #sec_token => $token,
                     };
    $t->post_ok('/api/v1/relation' => {Accept => '*/*'} => json => $post_data)
      ->status_is(200)
      ->json_hasnt('/error');
    if ($t->tx->res->json->{error}) {
        diag("message: " . $t->tx->res->json->{message});
    }

    $post_data->{relation} = "none";
    $t->post_ok('/api/v1/relation' => {Accept => '*/*'} => json => $post_data)
      ->status_is(200)
      ->json_hasnt('/error');

    if ($t->tx->res->json && $t->tx->res->json->{error}) {
        diag("message: " . $t->tx->res->json->{message});
    }


    # logout
    $t->get_ok('/my/logout')->status_is(302);

    # finished. do cleanup...
    delete_user($t->app, "people1");
    delete_user($t->app, "people2");
};

done_testing();
