# -*-Perl-*-
# Newslash::Model::ADCodes related  tests
use Mojo::Base -strict;

use Test::More;
use Test::Mojo;
use Data::Dumper;
use DateTime::Format::MySQL;

my $t = Test::Mojo->new('Newslash::Web');

my $ad_codes = $t->app->model('ad_codes');
ok($ad_codes, "get AdCodes instance");

subtest 'create/select/update/delete ad_codes and items' => sub {
    plan skip_all => "mode is not 'test'" if ($t->app->mode ne 'test');

    my $test_name = "test_feed";
    my $test_content = "テストのコード本体";

    my $rs = $ad_codes->select(name => $test_name);
    $ad_codes->delete(ad_id => $rs->{ad_id}) if $rs;

    my $ad_id = $ad_codes->create(name => $test_name,
                                  content => $test_content);
    ok($ad_id, "create ad_code");

    my $ad_code = $ad_codes->select(ad_id => $ad_id);
    ok($ad_code, "select ad_code by ad_id");
    is($ad_code->{name}, $test_name, "retrive valid name");
    is($ad_code->{status}, "enabled", "retrive valid status");
    is($ad_code->{content}, $test_content, "retrive valid content");

    $ad_code = $ad_codes->select(name => $test_name);
    ok($ad_code, "select ad_code by name");
    is($ad_code->{name}, $test_name, "retrive valid ad_code");

    my $test_description = "説明2";
    ok($ad_codes->update(ad_id => $ad_id,
                         description => $test_description),
       "update ad_code");

    ok($ad_codes->delete(id => $ad_id), "delete item");
};


# cleanup

done_testing();
