# -*-Perl-*-
# basic simple and non-destructive tests
use Mojo::Base -strict;

use Test::More;
use Test::Mojo;

my $t = Test::Mojo->new('Newslash::Web');

my $app = $t->app;

subtest 'TimeLimitedCache test' => sub {
    plan tests => 6;

    # test_mode off
    $app->cache->{test_mode} = 0;

    # test 1-3
    $app->cache->set(foo => "foo is foo", 1000);
    is($app->cache->get("foo"), "foo is foo", "cache->get");
    is($app->cache->del("foo"), "foo is foo", "cache->del (step1)");
    ok(!defined($app->cache->get("foo")), "cache->del (step2)");

    # test 4
    $app->cache->set(bar => "bar bar bar", 1);
    sleep 1;
    ok(!defined($app->cache->get("bar")), "check expire");

    # test_mode on
    $app->cache->{test_mode} = 1;
    $app->cache->set(foo => "foo is foo", 1000);
    ok(!$app->cache->get("foo"), "cache->get in test_mode");
    ok(!$app->cache->del("foo"), "cache->del in test_mode");
};

done_testing;
